package org.ids_mannheim;

import java.util.LinkedList;

public class SlidingWindowQueue extends LinkedList<String> {
    final int maxSize;
    final Increaser flush;
    final boolean with_lemma_and_pos;
    public int fold;

    public SlidingWindowQueue(int size, Increaser flush, boolean with_lemma_and_pos) {
        this.maxSize = size;
        this.flush = flush;
        this.with_lemma_and_pos = with_lemma_and_pos;
    }

    public boolean add(String k) {
        super.add(k);
        if (size() == maxSize) {
            this.flush.accept(String.join("\t", this));
            remove(0);
        }
        return true;
    }

    public void reset(int fold) {
        this.clear();
        this.fold = fold;
    }

    public void textBreak() {
    }

    interface Increaser {
        void accept(String s);
    }
}
